#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include <time.h>
#include <commctrl.h>
#include "FTD2XX.H"
#include "RESOURCE.H"

FT_HANDLE ftHandle;
FT_STATUS ftStatus;

HANDLE hRxThread;
DWORD ThRxID;
HANDLE hEvent;
HWND hDlg;
time_t start, finish;
int bus_busy;

DWORD CALLBACK GetRxQueue( void *param )
{ 
	BYTE FT_RXD[4096];
	DWORD dwRxBytes = 0;
	DWORD RxQueSize = 0;
	DWORD sum_bytes = 0;
	FT_STATUS ftRxStatus;
	double elapsed_time;
	double unit_time;
	char cbuf[256];

	while(TRUE) {
		//IuWFNgVOiԂƂȂ܂őҋ@
		WaitForSingleObject( hEvent, INFINITE ) ;

		FT_GetQueueStatus( ftHandle, &RxQueSize );
		ftRxStatus = FT_Read( ftHandle, FT_RXD, RxQueSize, &dwRxBytes );	

		sum_bytes += dwRxBytes;

		SendMessage( GetDlgItem(hDlg, ID_PBM), PBM_SETPOS, sum_bytes, 0 );

		sprintf( cbuf, "M %d oCg", sum_bytes ); 
		SetWindowText( hDlg, cbuf);
		ZeroMemory( cbuf, 256 );

		if( sum_bytes == 5000000 ) {
			
			SetWindowText( hDlg, "TloCgM");

			time( &finish );
			sum_bytes = 0;
			bus_busy = 0;
			elapsed_time = difftime( finish, start );
			sprintf( cbuf, "%f", elapsed_time );
			SetDlgItemText( hDlg, IDC_TIME, cbuf);

			unit_time = (5000000 + 4096)/elapsed_time/1000.0;
			sprintf( cbuf, "%d", (int)unit_time );
			SetDlgItemText( hDlg, IDC_UNIT, cbuf);
		} 
	} 
	return 0;
}

void PushButton( HWND hDlg, FT_HANDLE ftHandle, WPARAM wParam )
{
	BYTE FT_TXD[4096];
	DWORD dwTxBytes = 0;
	FT_STATUS ftTxStatus;
	int i;

	switch(wParam) {
	case IDC_BUTTON_SND: {

		if(bus_busy)
			return;

		bus_busy = 1;

		FT_Purge( ftHandle, FT_PURGE_RX | FT_PURGE_TX); // obt@NA

		for( i=0; i<4096; i++ )
			FT_TXD[i] = i;

		time( &start );
		ftTxStatus = FT_Write( ftHandle, FT_TXD, 4096, &dwTxBytes );

		break;
						 } //DC_BUTTON_SND

	}
}

BOOL CALLBACK dlgproc( HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam )
{
	switch(message)
	{
	case WM_INITDIALOG: 
		{
			SendMessage( GetDlgItem(hDlg, ID_PBM), PBM_SETRANGE32, 0, 5000000 );

			// EBhE/ɃXe[^X擾
			ftStatus = FT_OpenEx("ASB-004-TEST08", FT_OPEN_BY_DESCRIPTION, &ftHandle);

			if( ftStatus == FT_OK ) {
				FT_ResetDevice( ftHandle );                     // foCXZbg
				FT_Purge( ftHandle, FT_PURGE_RX | FT_PURGE_TX); // obt@NA
				FT_SetTimeouts( ftHandle, NULL, NULL );         // ^CAEg̐ݒ
				Sleep(150);

				// VOiԂƂāCCxgIuWFNg𐶐
				hEvent = CreateEvent( NULL, FALSE, FALSE, NULL );
				FT_SetEventNotification( ftHandle, FT_EVENT_RXCHAR, hEvent );

				hRxThread = CreateThread( NULL, 0, GetRxQueue, NULL, 0, &ThRxID ) ;
				SetEvent( hEvent );
			}
			else {
				MessageBox( hDlg, "I[vł܂", "G[", MB_ICONWARNING );
			}

			break;
		}

	case WM_COMMAND: 
		{
			if( ftStatus == FT_OK ) {
				PushButton( hDlg, ftHandle, wParam );
			}
			else {
				MessageBox( hDlg, "I[vł܂", "G[", MB_ICONWARNING );
			}

			break;
		}

	case WM_CLOSE:
		{
			// IɃnh
			CloseHandle( hEvent );
			FT_Close( ftHandle );
			PostQuitMessage(0);
			break;
		}
	}

	return false;
}

int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE, LPSTR, int )
 {
	MSG msg;

	hEvent = 0;

	hDlg = CreateDialog( hInstance, "DLG_DATA", 0, (DLGPROC)dlgproc );

    while(GetMessage( &msg, NULL, 0, 0) )
	{
        TranslateMessage( &msg );
		DispatchMessage( &msg );
    }

	return (int)msg.wParam;
}